## snuffleupagus 0.12.0

=== Makefile ===
.DEFAULT_GOAL=help
.PHONY=help
SHELL = /bin/bash

SRC := src

clean:  ## clean everything
	make -C $(SRC) clean
	cd $(SRC); phpize --clean

release:  ## compile with releases flags
	cd $(SRC); phpize
	cd $(SRC); ./configure --enable-snuffleupagus
	make -C $(SRC)
	strip $(SRC)/.libs/snuffleupagus.so

install: release  ## compile and install snuffleupagus
	make -C $(SRC) install

compile_debug:  ## compile a debug build
	cd $(SRC); if [[ ! -f configure ]]; then phpize; fi; \
	./configure --enable-snuffleupagus --enable-debug --enable-debug-stderr && \
	make clean ; make -j4

DOCKER_IMAGE := php:latest
docker: ## start docker container with current PHP
	@echo "Starting new docker container with snuffleupagus bind-mounted to /sp"
	docker run -it -v "$$(pwd)":/sp $(DOCKER_IMAGE) /bin/bash

linked-clone:
	@if [[ "$(CLONE)" == "" ]]; then echo -e "==> Please provide clone name, e.g.\n  make linked-clone CLONE=php8.1\n"; exit 1; fi
	@if [[ -d "src-$(CLONE)" ]]; then echo -e "==> Clone '$(CLONE)' already exists.\n"; exit 1; fi
	@echo "==> CREATING LINKED CLONE IN 'src-$(CLONE)' <=="
	mkdir "src-$(CLONE)"; cd "src-$(CLONE)"; \
	SRCDIR=../src; ln -s $$SRCDIR/*.[hc] $$SRCDIR/config.m4 $$SRCDIR/snuffleupagus.php $$SRCDIR/Makefile.frag $$SRCDIR/*.re .; \
	cp -r $$SRCDIR/tests .
	@echo -e "==> DONE. <==\nCompile a debug build with\n  make compile_debug SRC=src-$(CLONE)"

tests: release tests-incremental  ## compile a release build and run the testsuite

tests-incremental:  ## perform an incremental build and run the testsuite
	make -C $(SRC)
	TEST_PHP_ARGS='-q' REPORT_EXIT_STATUS=1 make -C $(SRC) test

coverage:  ## compile snuffleugpaus, and run the testsuite with coverage
	cd $(SRC); phpize
ifeq ($(CC),clang)
	cd $(SRC); CFLAGS="-fprofile-instr-generate -fcoverage-mapping" ./configure --enable-snuffleupagus
	make -C $(SRC)
	sed -i "s/\$$ext_params -d display_errors=0 -r/-d display_errors=0 -r/" $(SRC)/run-tests.php
	LLVM_PROFILE_FILE="sp_%p_%m.profraw" TEST_PHP_ARGS='-q' REPORT_EXIT_STATUS=1 make -C $(SRC) test
	llvm-profdata-4.0 merge ./$(SRC)/*.profraw -o ./$(SRC)/sp.profdata
	llvm-cov report -instr-profile=./$(SRC)/sp.profdata ./$(SRC)/modules/snuffleupagus.so
else
	cd $(SRC); ./configure --enable-snuffleupagus --enable-coverage
	make -C $(SRC)
	rm -Rf $(SRC)/COV.html
	sed -i "s/\$$ext_params -d display_errors=0 -r/-d display_errors=0 -r/" $(SRC)/run-tests.php
	TEST_PHP_ARGS='-q' REPORT_EXIT_STATUS=1 make -C $(SRC) test
	lcov --base-directory ./$(SRC) --directory ./$(SRC) -c -o ./$(SRC)/COV.info --rc lcov_branch_coverage=1 
	lcov --remove $(SRC)/COV.info '/usr/*' --remove $(SRC)/COV.info '*tweetnacl.c' -o $(SRC)/COV.info --rc lcov_branch_coverage=1
	genhtml --show-details -o $(SRC)/COV.html ./$(SRC)/COV.info  --branch-coverage
endif

bench: joomla  ## run the benchmark

joomla:
	if [ ! -d "joomla-cms" ]; then \
		git clone --depth 1 https://github.com/joomla/joomla-cms.git >/dev/null; \
	fi
	cd joomla-cms; composer install >/dev/null 2>/dev/null
	echo "\nWith snuffleupagus:"
	cd joomla-cms; time php -d "extension=../$(SRC)/modules/snuffleupagus.so" -d "sp.configuration_file=../config/default.rules" libraries/vendor/phpunit/phpunit/phpunit --no-coverage >/dev/null
	echo "\nWithout snuffleupagus:"
	cd joomla-cms; time php libraries/vendor/phpunit/phpunit/phpunit --no-coverage >/dev/null

packages: debian  ## produce packages

debian:
	dpkg-buildpackage -i -us -uc -tc -I -rfakeroot

help:
	@awk -F ':|##' '/^[^\t].+?:.*?##/ { printf "\033[36m%-30s\033[0m %s\n", $$1, $$NF }' $(MAKEFILE_LIST) | sort

.PHONY: debian

=== debian/changelog ===
snuffleupagus (0.12.0-1) unstable; urgency=medium

  * Initial Release. (Closes: #894821)

 -- Christian Göttsche <cgzones@googlemail.com>  Sat, 23 Aug 2025 14:56:41 +0200

=== debian/control ===
Source: snuffleupagus
Priority: optional
Maintainer: Christian Göttsche <cgzones@googlemail.com>
Build-Depends: debhelper-compat (= 13),
               dh-php,
               php-curl <!nocheck>,
               php-dev,
               php-xml <!nocheck>,
               re2c,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://snuffleupagus.readthedocs.io
Section: php
Vcs-Git: https://salsa.debian.org/cgzones/snuffleupagus.git
Vcs-Browser: https://salsa.debian.org/cgzones/snuffleupagus

Package: php-snuffleupagus
Architecture: any
Depends: ${misc:Depends},
         ${php:Depends},
         ${shlibs:Depends},
Description: Security module for php7 and php8
 Snuffleupagus is a PHP 7+ and 8+ module designed to drastically raise the
 cost of attacks against websites, by killing entire bug classes. It also
 provides a powerful virtual-patching system, allowing administrator to fix
 specific vulnerabilities and audit suspicious behaviours without having to
 touch the PHP code.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
export DEB_CFLAGS_MAINT_APPEND = -Werror

PHP_VERSION := $(shell phpquery -q -V)

%:
	dh $@ --sourcedirectory src --with php

execute_after_dh_auto_clean:
	cd ./src; /usr/bin/phpize --clean

override_dh_auto_configure:
	cd ./src; /usr/bin/phpize
	dh_auto_configure --sourcedirectory src -- --enable-snuffleupagus

override_dh_auto_test:
	REPORT_EXIST_STATUS=1 NO_INTERACTION=1 dh_auto_test --sourcedirectory src

override_dh_auto_install:
	# update configuration file path
	sed -e 's/@PHP_VERSION@/${PHP_VERSION}/' $(CURDIR)/debian/snuffleupagus.ini.in > $(CURDIR)/debian/snuffleupagus.ini

	# phpize uses INSTALL_ROOT instead of DESTDIR
	INSTALL_ROOT=$(CURDIR)/debian/php-snuffleupagus dh_auto_install --sourcedirectory src

	# install default configuration file
	mkdir -p $(CURDIR)/debian/php-snuffleupagus/etc/php/${PHP_VERSION}/conf.d/
	cp $(CURDIR)/config/default.rules $(CURDIR)/debian/php-snuffleupagus/etc/php/${PHP_VERSION}/conf.d/snuffleupagus.rules

=== debian/watch ===
version=4
opts=filenamemangle=s%.+/@ANY_VERSION@%@PACKAGE@-$1\.tar\.gz% \
  https://github.com/jvoisin/snuffleupagus/tags .*/@ANY_VERSION@\.tar\.gz

## snuffleupagus 0.13.0

=== doc/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = Snuffleupagus
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== debian/changelog ===
snuffleupagus (0.13.0-1) unstable; urgency=medium

  * New upstream version 0.13.0
    - fixes CVE-2026-22034

  * Adjust to moved PHP 8 default rules
  * d/control:
    - drop priority and R^3 fields with default value
    - bump to std version 4.7.3 (no further changes)
  * d/watch: rewrite in version 5
  * d/copyright: bump years
  * d/patches: add nonstring attribute to fix GCC 15 build (Closes: #1126792)

 -- Christian Göttsche <cgzones@googlemail.com>  Sun, 01 Feb 2026 21:13:36 +0100

=== debian/watch ===
Version: 5
Template: Github
Owner: jvoisin
Project: snuffleupagus

## snuffleupagus 0.13.0%2Bds

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,4 @@
 Source: snuffleupagus
-Priority: optional
 Maintainer: Christian Göttsche <cgzones@googlemail.com>
 Build-Depends: debhelper-compat (= 13),
                dh-php,
@@ -7,8 +6,7 @@
                php-dev,
                php-xml <!nocheck>,
                re2c,
-Standards-Version: 4.7.2
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Homepage: https://snuffleupagus.readthedocs.io
 Section: php
 Vcs-Git: https://salsa.debian.org/cgzones/snuffleupagus.git

## snuffleupagus 0.13.0+ds

=== debian/changelog ===
snuffleupagus (0.13.0+ds-1) unstable; urgency=medium

  * Add repack suffix for excluded files
  * d/patches:
    + add patch for PATH_MAX compatibility
    + add patch to constify function pointer tables
    + add patch to use correct parser for session ID lengths
    + add patch to generalize disabled_functions_regexp_multiple.phpt
      expected output
  * d/rules: show unit test failures to enable debugging them
  * d/tests: run testsuite by autopkgtests
  * d/salsa-ci.yml: drop deprecated build-twice job

 -- Christian Göttsche <cgzones@googlemail.com>  Sun, 22 Feb 2026 23:05:05 +0100

=== debian/rules ===
--- 
+++ 
@@ -21,7 +21,7 @@
 	dh_auto_configure --sourcedirectory src -- --enable-snuffleupagus
 
 override_dh_auto_test:
-	REPORT_EXIST_STATUS=1 NO_INTERACTION=1 dh_auto_test --sourcedirectory src
+	REPORT_EXIST_STATUS=1 NO_INTERACTION=1 dh_auto_test --sourcedirectory src || (find src/tests/ \( -name "*\.diff" -o -name "*\.log" \) -print -execdir cat {} \; ; exit 1)
 
 override_dh_auto_install:
 	# update configuration file path

=== debian/tests/control ===
Tests: testsuite
Depends: php-cgi, php-curl, php-xml, @builddeps@
Restrictions: allow-stderr

=== debian/watch ===
Version: 5
Template: Github
Owner: jvoisin
Project: snuffleupagus
Dversion-Mangle: auto
Repacksuffix: +ds
